Summary:        Beep the PC speaker any number of ways
Name:           beep
Version:        1.3
Release:        26%{?dist}

Group:          Applications/System
License:        GPLv2+
URL:            http://www.johnath.com/beep/

# Upstream github repo: https://github.com/johnath/beep
# hun github repo:      https://github.com/ndim/beep

# Alternative source URLs to download:
# curl -L -o beep-github.tar.gz https://api.github.com/repos/johnath/beep/tarball
# curl -L -o beep-g0d790fa.tar.gz https://api.github.com/repos/johnath/beep/tarball/0d790fa
# curl -L -o beep-1.3-gdb6f31a.tar.gz https://api.github.com/repos/johnath/beep/tarball/db6f31a60303e41def1a1d0705164cd5b6d75492
Source0:        http://www.johnath.com/beep/%{name}-%{version}.tar.gz


# Fedora specific files
Source1:        %{name}-README.fedora
Source2:        %{name}-modprobe.conf
Source3:        %{name}.sudoers
Source4:        %{name}.csh
Source5:        %{name}.sh
Source6:        90-pcspkr-beep.rules


# Helping commands see README-packaging.md

# Fix from upstream github repo
Patch1:         0001-Fixed-Makefile.patch

# Fix from upstream github repo
Patch2:         0002-Add-more-error-detection.patch

# No sense to add stuff to .gitignore in our source dir
# Patch3:         0003-Gitignorance.patch

# Fix from upstream github repo
Patch4:         0004-also-catch-SIGTERM-for-stopping-the-beep.patch

# Make build/install more user and packaging friendly
# https://github.com/johnath/beep/pull/6
Patch5:         0005-Make-build-install-more-user-and-packaging-friendly.patch

# Preserve file modification time on install
# https://github.com/johnath/beep/pull/6
Patch6:         0006-Preserve-file-modification-time-on-install.patch

# Fix indentation/if brace error
Patch7:         0007-Fix-indentation-if-brace-error.patch

# Apply CVE-2018-0492.patch from Debian package
Patch8:         0008-Apply-CVE-2018-0492.patch-from-Debian-package.patch

# store uncompressed beep.1 file in source repository
Patch9:         0009-store-uncompressed-beep.1-file-in-source-repository.patch

# No sense to add stuff to .gitignore in our source dir
# gitignore: intermediate build results
# Patch10:        0010-gitignore-intermediate-build-results.patch

# constrain freq and period values
Patch11:        0011-constrain-freq-and-period-values.patch

# get rid of a few signed int and unchecked input value ranges
Patch12:        0012-get-rid-of-a-few-signed-int-and-unchecked-input-valu.patch

# Fix CVE-2018-1000532 and mitigate against related issues
Patch13:        0013-Fix-CVE-2018-1000532-and-mitigate-against-related-is.patch

# Update COPYING with new FSF address
Patch14:        0014-Update-COPYING-with-new-FSF-address.patch

# If do_beep() sees error from API, exit program
Patch15:        0015-If-do_beep-sees-error-from-API-exit-program.patch

# Make the evdev device the first to look for
Patch16:        0016-Make-the-evdev-device-the-first-to-look-for.patch

# Use realpath(3) on device name
Patch17:        0017-Use-realpath-3-on-device-name.patch

# refuse to run when setuid or setgid usage detected
Patch18:        0018-refuse-to-run-when-setuid-or-setgid-usage-detected.patch

# add setuid/setgid check output newline
Patch19:        0019-add-setuid-setgid-check-output-newline.patch

# refuse to run under sudo
Patch20:        0020-refuse-to-run-under-sudo.patch

# print console_device in verbose message on BEEP_TYPE_
Patch21:        0021-print-console_device-in-verbose-message-on-BEEP_TYPE.patch

# restructure device whitelisting code
Patch22:        0022-restructure-device-whitelisting-code.patch

# README, beep.1; remove setuid suggestions
Patch23:        0023-README-beep.1-remove-setuid-suggestions.patch


BuildRequires:  gcc
BuildRequires:  glibc-kernheaders
# for the udev macros
BuildRequires:  systemd

Requires(pre):  shadow-utils


%description
Beep allows the user to control the PC speaker with precision,
allowing different sounds to indicate different events. While it
can be run quite happily on the command line, its intended place
of residence is within shell/Perl scripts, notifying the user when
something interesting occurs. Of course, it has no notion of
what's interesting, but it's real good at that notifying part.


%prep
%setup -q
%patch1 -p1 -b 0001
%patch2 -p1 -b 0002
%patch4 -p1 -b 0004
%patch5 -p1 -b 0005
%patch6 -p1 -b 0006
%patch7 -p1 -b 0007
%patch8 -p1 -b 0008
%patch9 -p1 -b 0009
rm -f beep.1.gz
%patch11 -p1 -b 0011
%patch12 -p1 -b 0012
%patch13 -p1 -b 0013
%patch14 -p1 -b 0014
%patch15 -p1 -b 0015
%patch16 -p1 -b 0016
%patch17 -p1 -b 0017
%patch18 -p1 -b 0018
%patch19 -p1 -b 0019
%patch20 -p1 -b 0020
%patch21 -p1 -b 0021
%patch22 -p1 -b 0022
%patch23 -p1 -b 0023
cp -p %{SOURCE1} README.fedora


%build
make %{?_smp_mflags} FLAGS="" CFLAGS="-Wall -Wextra -Werror -std=gnu99 -pedantic ${RPM_OPT_FLAGS}"


%install
rm -rf "$RPM_BUILD_ROOT"
make install DESTDIR="$RPM_BUILD_ROOT"

install -d -m 0755            "$RPM_BUILD_ROOT/%{_sysconfdir}/modprobe.d/"
install -p -m 0644 %{SOURCE2} "$RPM_BUILD_ROOT/%{_sysconfdir}/modprobe.d/beep.conf"

install -d -m 0755            "$RPM_BUILD_ROOT/%{_udevrulesdir}/"
install -p -m 0644 %{SOURCE6} "$RPM_BUILD_ROOT/%{_udevrulesdir}/"


%pre
getent group beep >/dev/null || groupadd -r beep
exit 0


%files
%doc CHANGELOG COPYING CREDITS README
%attr(0755,root,root) %{_bindir}/beep
%{_mandir}/man1/beep.1.gz
%doc README.fedora
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/modprobe.d/beep.conf
%{_udevrulesdir}/90-pcspkr-beep.rules


%changelog
* Sat Dec 29 2018 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-26
- Stop shipping old sudo related config files
- Refuse to run when run via sudo
- Set up group 'beep' for write access to evdev device with new udev rule
- Update README.fedora to reflect new group permission setup on evdev device

* Fri Dec 28 2018 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-25
- guard against directory traversal in /dev/input/ check
- refuse to run if setuid or setgid root
- make the evdev device the first device to look for (does not require root)

* Fri Dec 28 2018 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-24
- Actually apply the patches
- Update COPYING with new FSF address
- Fix Patch9 to work as non-git patch (do the rest with shell)
- Proper naming of Patch14
- Exit beep when error accessing API

* Fri Dec 28 2018 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-23
- Fix CVE-2018-1000532 and mitigate against related issues (#1595592)
- Fix a number of potential integer overflows

* Thu Jul 12 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Apr  3 2018 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-21
- Add CVE-2018-0492 fix.
- Behaviour of multiple -f parameters matches documentation now.

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-20
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue May 31 2016 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-16
- Use more appropriate sox play example in README.fedora
- Make command line examples more readable in README.fedora

* Tue May 31 2016 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-15
- Add shell aliases to allow non-root users to run beep from the shell
- Fix mail address in %%changelog

* Tue May 31 2016 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-14
- Document how non-root users can run beep via sudo (#1133231)
- Remove spec file conditional required in Fedora 12 times

* Mon May 16 2016 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-13
- Remove useless %%defattr for clarity

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.3-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Jan 17 2016 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-11
- Do not replace config file modprobe.d/beep.conf (#1087616)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Nov 19 2013 Hans Ulrich Niedermann  <hun@n-dimensional.de> - 1.3-7
- Use new upstream tarball beep-1.3.tar.gz (yes, it has changed!)
- Add a few fixes from upstream git repo
- Move our Makefile cleanup to upstream pull request

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jan 12 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Jul 16 2010 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.3-1
- Update to upstream release beep-1.3

* Fri Jan 22 2010 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.2.2-6
- Ship modprobe config file with alias for pcspkr on F12 and later

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Sep  7 2008 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.2.2-3
- Initial package for submission to Fedora
